#include "StdAfx.h"
#include "AbstractControl.h"
#include "AbstractModel.h"
#include "AbstractView.h"
#include "AbstractCommand.h"

AbstractControl::AbstractControl(void)
{
}

AbstractControl::~AbstractControl(void)
{
}
void AbstractControl::SetView(AbstractView* view)
{
	m_View = view;
}
void AbstractControl::SetModel(AbstractModel* model)
{
	m_Model = model;
}
BOOL AbstractControl::PushUndoCommand(AbstractCommand* command, BOOL bRemoveRedo)
{
	m_stackUndo.push(command);
	if (bRemoveRedo)
		StackRemoveAll(m_stackRedo);

	//Fire_ChangeCommandManager();
	return TRUE;
}
BOOL AbstractControl::PushRedoCommand(AbstractCommand* command)
{
	m_stackRedo.push(command);

	//Fire_ChangeCommandManager();
	return TRUE;
}
/**
* @brief	pop undo command
* @return	AbstractCommand*
*/
AbstractCommand* AbstractControl::PopUndoCommand()
{
	AbstractCommand* pCommand = m_stackUndo.top();
	m_stackUndo.pop();

	//Fire_ChangeCommandManager();
	return pCommand;
}
AbstractCommand* AbstractControl::PeekUndoCommand()
{
	if( m_stackUndo.size() == 0 )
		return NULL;

	AbstractCommand* pCommand = m_stackUndo.top();
	return pCommand;
}
AbstractCommand* AbstractControl::PopRedoCommand()
{
	AbstractCommand* pCommand = m_stackRedo.top();
	m_stackRedo.pop();

	//Fire_ChangeCommandManager();
	return pCommand;
}
AbstractCommand* AbstractControl::PeekRedoCommand()
{
	if( m_stackRedo.size() == 0 )
		return NULL;

	AbstractCommand* pCommand = m_stackRedo.top();
	return pCommand;
}
void AbstractControl::Reset()
{
	StackRemoveAll(m_stackUndo);
	StackRemoveAll(m_stackRedo);
	//Fire_ChangeCommandManager();
}
void AbstractControl::StackRemoveAll(std::stack<AbstractCommand*>& stackCommand)
{
	int size = stackCommand.size();
	while (size > 0)
	{
		AbstractCommand* pCommand = stackCommand.top();
		stackCommand.pop();
		delete pCommand;
		size--;
	}
}